<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for cargoCompanyDetails StructType
 * @subpackage Structs
 */
class CargoCompanyDetails extends AbstractStructBase
{
    /**
     * The cargoCompanyDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CargoCompanyDetailType[]
     */
    public $cargoCompanyDetail;
    /**
     * Constructor method for cargoCompanyDetails
     * @uses CargoCompanyDetails::setCargoCompanyDetail()
     * @param \StructType\CargoCompanyDetailType[] $cargoCompanyDetail
     */
    public function __construct(array $cargoCompanyDetail = array())
    {
        $this
            ->setCargoCompanyDetail($cargoCompanyDetail);
    }
    /**
     * Get cargoCompanyDetail value
     * @return \StructType\CargoCompanyDetailType[]|null
     */
    public function getCargoCompanyDetail()
    {
        return $this->cargoCompanyDetail;
    }
    /**
     * This method is responsible for validating the values passed to the setCargoCompanyDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCargoCompanyDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCargoCompanyDetailForArrayConstraintsFromSetCargoCompanyDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $cargoCompanyDetailsCargoCompanyDetailItem) {
            // validation for constraint: itemType
            if (!$cargoCompanyDetailsCargoCompanyDetailItem instanceof \StructType\CargoCompanyDetailType) {
                $invalidValues[] = is_object($cargoCompanyDetailsCargoCompanyDetailItem) ? get_class($cargoCompanyDetailsCargoCompanyDetailItem) : sprintf('%s(%s)', gettype($cargoCompanyDetailsCargoCompanyDetailItem), var_export($cargoCompanyDetailsCargoCompanyDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The cargoCompanyDetail property can only contain items of type \StructType\CargoCompanyDetailType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set cargoCompanyDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\CargoCompanyDetailType[] $cargoCompanyDetail
     * @return \StructType\CargoCompanyDetails
     */
    public function setCargoCompanyDetail(array $cargoCompanyDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($cargoCompanyDetailArrayErrorMessage = self::validateCargoCompanyDetailForArrayConstraintsFromSetCargoCompanyDetail($cargoCompanyDetail))) {
            throw new \InvalidArgumentException($cargoCompanyDetailArrayErrorMessage, __LINE__);
        }
        $this->cargoCompanyDetail = $cargoCompanyDetail;
        return $this;
    }
    /**
     * Add item to cargoCompanyDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\CargoCompanyDetailType $item
     * @return \StructType\CargoCompanyDetails
     */
    public function addToCargoCompanyDetail(\StructType\CargoCompanyDetailType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CargoCompanyDetailType) {
            throw new \InvalidArgumentException(sprintf('The cargoCompanyDetail property can only contain items of type \StructType\CargoCompanyDetailType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->cargoCompanyDetail[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CargoCompanyDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
