<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for productServiceProcessResponse StructType
 * @subpackage Structs
 */
class ProductServiceProcessResponse extends BaseResponse
{
    /**
     * The successfulProcesses
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SuccessfulProcesses
     */
    public $successfulProcesses;
    /**
     * The failedProcesses
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\FailedProcesses
     */
    public $failedProcesses;
    /**
     * The result
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $result;
    /**
     * Constructor method for productServiceProcessResponse
     * @uses ProductServiceProcessResponse::setSuccessfulProcesses()
     * @uses ProductServiceProcessResponse::setFailedProcesses()
     * @uses ProductServiceProcessResponse::setResult()
     * @param \StructType\SuccessfulProcesses $successfulProcesses
     * @param \StructType\FailedProcesses $failedProcesses
     * @param string $result
     */
    public function __construct(\StructType\SuccessfulProcesses $successfulProcesses = null, \StructType\FailedProcesses $failedProcesses = null, $result = null)
    {
        $this
            ->setSuccessfulProcesses($successfulProcesses)
            ->setFailedProcesses($failedProcesses)
            ->setResult($result);
    }
    /**
     * Get successfulProcesses value
     * @return \StructType\SuccessfulProcesses|null
     */
    public function getSuccessfulProcesses()
    {
        return $this->successfulProcesses;
    }
    /**
     * Set successfulProcesses value
     * @param \StructType\SuccessfulProcesses $successfulProcesses
     * @return \StructType\ProductServiceProcessResponse
     */
    public function setSuccessfulProcesses(\StructType\SuccessfulProcesses $successfulProcesses = null)
    {
        $this->successfulProcesses = $successfulProcesses;
        return $this;
    }
    /**
     * Get failedProcesses value
     * @return \StructType\FailedProcesses|null
     */
    public function getFailedProcesses()
    {
        return $this->failedProcesses;
    }
    /**
     * Set failedProcesses value
     * @param \StructType\FailedProcesses $failedProcesses
     * @return \StructType\ProductServiceProcessResponse
     */
    public function setFailedProcesses(\StructType\FailedProcesses $failedProcesses = null)
    {
        $this->failedProcesses = $failedProcesses;
        return $this;
    }
    /**
     * Get result value
     * @return string|null
     */
    public function getResult()
    {
        return $this->result;
    }
    /**
     * Set result value
     * @param string $result
     * @return \StructType\ProductServiceProcessResponse
     */
    public function setResult($result = null)
    {
        // validation for constraint: string
        if (!is_null($result) && !is_string($result)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($result, true), gettype($result)), __LINE__);
        }
        $this->result = $result;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ProductServiceProcessResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
