<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for sameDayDeliveryTypes StructType
 * @subpackage Structs
 */
class SameDayDeliveryTypes extends AbstractStructBase
{
    /**
     * The sameDayDeliveryType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SameDayDeliveryType[]
     */
    public $sameDayDeliveryType;
    /**
     * Constructor method for sameDayDeliveryTypes
     * @uses SameDayDeliveryTypes::setSameDayDeliveryType()
     * @param \StructType\SameDayDeliveryType[] $sameDayDeliveryType
     */
    public function __construct(array $sameDayDeliveryType = array())
    {
        $this
            ->setSameDayDeliveryType($sameDayDeliveryType);
    }
    /**
     * Get sameDayDeliveryType value
     * @return \StructType\SameDayDeliveryType[]|null
     */
    public function getSameDayDeliveryType()
    {
        return $this->sameDayDeliveryType;
    }
    /**
     * This method is responsible for validating the values passed to the setSameDayDeliveryType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSameDayDeliveryType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSameDayDeliveryTypeForArrayConstraintsFromSetSameDayDeliveryType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $sameDayDeliveryTypesSameDayDeliveryTypeItem) {
            // validation for constraint: itemType
            if (!$sameDayDeliveryTypesSameDayDeliveryTypeItem instanceof \StructType\SameDayDeliveryType) {
                $invalidValues[] = is_object($sameDayDeliveryTypesSameDayDeliveryTypeItem) ? get_class($sameDayDeliveryTypesSameDayDeliveryTypeItem) : sprintf('%s(%s)', gettype($sameDayDeliveryTypesSameDayDeliveryTypeItem), var_export($sameDayDeliveryTypesSameDayDeliveryTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The sameDayDeliveryType property can only contain items of type \StructType\SameDayDeliveryType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set sameDayDeliveryType value
     * @throws \InvalidArgumentException
     * @param \StructType\SameDayDeliveryType[] $sameDayDeliveryType
     * @return \StructType\SameDayDeliveryTypes
     */
    public function setSameDayDeliveryType(array $sameDayDeliveryType = array())
    {
        // validation for constraint: array
        if ('' !== ($sameDayDeliveryTypeArrayErrorMessage = self::validateSameDayDeliveryTypeForArrayConstraintsFromSetSameDayDeliveryType($sameDayDeliveryType))) {
            throw new \InvalidArgumentException($sameDayDeliveryTypeArrayErrorMessage, __LINE__);
        }
        $this->sameDayDeliveryType = $sameDayDeliveryType;
        return $this;
    }
    /**
     * Add item to sameDayDeliveryType value
     * @throws \InvalidArgumentException
     * @param \StructType\SameDayDeliveryType $item
     * @return \StructType\SameDayDeliveryTypes
     */
    public function addToSameDayDeliveryType(\StructType\SameDayDeliveryType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SameDayDeliveryType) {
            throw new \InvalidArgumentException(sprintf('The sameDayDeliveryType property can only contain items of type \StructType\SameDayDeliveryType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->sameDayDeliveryType[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SameDayDeliveryTypes
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
