<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for successfulProcesses StructType
 * @subpackage Structs
 */
class SuccessfulProcesses extends AbstractStructBase
{
    /**
     * The successfulProcess
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProductSuccessProcessType[]
     */
    public $successfulProcess;
    /**
     * Constructor method for successfulProcesses
     * @uses SuccessfulProcesses::setSuccessfulProcess()
     * @param \StructType\ProductSuccessProcessType[] $successfulProcess
     */
    public function __construct(array $successfulProcess = array())
    {
        $this
            ->setSuccessfulProcess($successfulProcess);
    }
    /**
     * Get successfulProcess value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProductSuccessProcessType[]|null
     */
    public function getSuccessfulProcess()
    {
        return isset($this->successfulProcess) ? $this->successfulProcess : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSuccessfulProcess method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSuccessfulProcess method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSuccessfulProcessForArrayConstraintsFromSetSuccessfulProcess(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $successfulProcessesSuccessfulProcessItem) {
            // validation for constraint: itemType
            if (!$successfulProcessesSuccessfulProcessItem instanceof \StructType\ProductSuccessProcessType) {
                $invalidValues[] = is_object($successfulProcessesSuccessfulProcessItem) ? get_class($successfulProcessesSuccessfulProcessItem) : sprintf('%s(%s)', gettype($successfulProcessesSuccessfulProcessItem), var_export($successfulProcessesSuccessfulProcessItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The successfulProcess property can only contain items of type \StructType\ProductSuccessProcessType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set successfulProcess value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ProductSuccessProcessType[] $successfulProcess
     * @return \StructType\SuccessfulProcesses
     */
    public function setSuccessfulProcess(array $successfulProcess = array())
    {
        // validation for constraint: array
        if ('' !== ($successfulProcessArrayErrorMessage = self::validateSuccessfulProcessForArrayConstraintsFromSetSuccessfulProcess($successfulProcess))) {
            throw new \InvalidArgumentException($successfulProcessArrayErrorMessage, __LINE__);
        }
        if (is_null($successfulProcess) || (is_array($successfulProcess) && empty($successfulProcess))) {
            unset($this->successfulProcess);
        } else {
            $this->successfulProcess = $successfulProcess;
        }
        return $this;
    }
    /**
     * Add item to successfulProcess value
     * @throws \InvalidArgumentException
     * @param \StructType\ProductSuccessProcessType $item
     * @return \StructType\SuccessfulProcesses
     */
    public function addToSuccessfulProcess(\StructType\ProductSuccessProcessType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProductSuccessProcessType) {
            throw new \InvalidArgumentException(sprintf('The successfulProcess property can only contain items of type \StructType\ProductSuccessProcessType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->successfulProcess[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SuccessfulProcesses
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
